<?php
/************************************************************************
© Nicolas Loeuillet, (28-06-2006)
nicolas.loeuillet@somb.org

Ce logiciel est un programme informatique servant à créer simplement
une galerie disponible sur le web.

Ce logiciel est régi par la licence CeCILL soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à 
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL, et que vous en avez accepté les
termes.
************************************************************************/

//
// Cookie stuff!
//
function check_cookie(&$nsgalphp_user)
{
	global $general, $cookie_name, $cookie_seed;

	$now = time();
	$expire = $now + 31536000;	// The cookie expires after a year

	// We assume it's a guest
	$cookie = array('user_id' => 1, 'password_hash' => 'Invité');

	// If a cookie is set, we get the user_id and password hash from it
	if (isset($_COOKIE['nsgalphp_cookie']))
	{
		list($cookie['user_id'], $cookie['password_hash']) = @unserialize(stripslashes($_COOKIE['nsgalphp_cookie']));
	}
	if ($cookie['user_id'] > 1)
	{
		// Check if there's a user with the user ID and password hash from the cookie
		$sql = 'SELECT u.*, g.* FROM '.$general['prefixeBDD'].'users AS u INNER JOIN '.$general['prefixeBDD'].'groupes AS g ON u.user_groupe=g.groupe_id WHERE u.user_id='.intval($cookie['user_id']);
		$result = mysql_query($sql);
		$nsgalphp_user = mysql_fetch_assoc($result);
		// If user authorisation failed
		if (!isset($nsgalphp_user['user_id']) || md5('308fea80'.$nsgalphp_user['user_pass']) !== $cookie['password_hash'])
		{
			$objetSerialise = serialize(array(0, random_pass(8)));
			pun_setcookie($objetSerialise, $expire);
			set_default_user();
			return;
		}
		$nsgalphp_user['is_guest'] = false;
	}
	else
		set_default_user();
}


//
// Fill $nsgalphp_user with default values (for guests)
//
function set_default_user()
{
	global $nsgalphp_user, $config, $general;

	// Fetch guest user
	$result = mysql_query('SELECT u.*, g.* FROM '.$general['prefixeBDD'].'users AS u INNER JOIN '.$general['prefixeBDD'].'groupes AS g ON u.user_groupe=g.groupe_id WHERE u.user_id=1');
	if (!mysql_num_rows($result))
		exit('Impossible de retrouver les informations invité. La table \''.$general['prefixeBDD'].'users\' doit contenir une entrée avec un id = 1 qui représente les utilisateurs anonymes.');
	$nsgalphp_user = mysql_fetch_assoc($result);
	$nsgalphp_user['is_guest'] = true;
}

//
// Set a cookie, PunBB style!
//
function pun_setcookie($objetSerialise, $expire)
{
	global $cookie_name, $cookie_path, $cookie_domain, $cookie_secure, $cookie_seed;
	// Enable sending of a P3P header by removing // from the following line (try this if login is failing in IE6)
	//	@header('P3P: CP="CUR ADM"');
	setcookie('nsgalphp_cookie', $objetSerialise, $expire, $cookie_path, $cookie_domain, $cookie_secure);
}

function pun_hash($str)
{
	if (function_exists('sha1'))	// Only in PHP 4.3.0+
		return sha1($str);
	else if (function_exists('mhash'))	// Only if Mhash library is loaded
		return bin2hex(mhash(MHASH_SHA1, $str));
	else
		return md5($str);
}

function random_pass($len)
{
	$chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
	$password = '';
	for ($i = 0; $i < $len; ++$i)
		$password .= substr($chars, (mt_rand() % strlen($chars)), 1);
	return $password;
}


/* Fonction qui traite les chaines pour enlever les caractères spéciaux
et les slashes */
function traitementChaine($str)
{
	return htmlentities(stripslashes($str));
}

/* Fonction qui retourne l'extension d'un fichier */
function getExtension($fichier)
{
    $bouts = explode(".", $fichier);
    $extension = array_pop($bouts);
    return $extension;
}

function imageCreateFromExtension($fichier)
{
	$extensionFichier = getExtension($fichier);
	return $extensionFichier;
}

/* Fonction qui vide un répertoire et le supprime */
function videEtSupprime($dossier, $supprime = 0)
{
	if(($dir=opendir($dossier))===false)
	{
		return;
	}
	while($name=readdir($dir))
	{
		if($name==='.' or $name==='..')
			continue;
		$full_name=$dossier.'/'.$name;
	
		if(is_dir($full_name))
			deltree($full_name);
		else
			unlink($full_name);
	}
	closedir($dir);
	if($supprime == 1)
		@rmdir($dossier);
}

?>